#ayudas.pm
# son ayudas para el programador; algunas para dar informacion al programador;
# otras para que sea mas facil programar ayudas para los usuarios
package Ayudas;
#use warnings;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys = 1;
our $HOME = $ENV{HOME};
our ($curdirori,$outdir); 
our (%progr,$progname);
our @MENSAJES;
our ($avisosgrav,$avisosnograv,$avisosnoseent)=(0,0,0);
our (%opt_hash,@opciones, $opciones, $debug, $noverb, $buscar, $imprlog);
our $presentacion;
BEGIN {
  use Exporter ();
  our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
  @ISA=qw(Exporter);
  @EXPORT=qw(&abrir_LSS1 
             &existencia
             &depurar_crudo
             &error_progr
             &juntar_por_signos_y_paren &juntar_por_paren 
             &juntar_por_signosf_y_paren
             &parser
             &cerrar_paren &sacar_paren_ext &comas_invalidas
             &union_conjunto &interseccion_conjunto &union_conorden
             &particion
             &hashrenglon 
             &impr &paraimpr3puntos 
             &imprhash 
             &imprhashrenglon
             &impr_debug 
	     &imprlisarb &imprlisarbresu 
	     &imprlislisarb
	     &imprnodarb &imprnodarbresu
	     &imprhashlis
             &impr_todo
	     &mensaje &eco &avgrav &avnograv &avnoseent &explic &avejec
             &mensajear
	     &pausa &pausaver &pausadebug
	     &relativizar
             &resolver_outdir
             &simpl_directory  
             &texto
             &textear_MENSAJES             
             $debug $noverb $buscar $avisosgrav $avisosnograv $avisosnoseent 
	     %progr $progname $imprlog
	     *LSS1
             @MENSAJES
	    );
};
END();
#----------------------------------------------------------------------------
sub abrir_LSS1{
  my ($nombrelss1,$progname,$modo) = @_;
  #impr_debug(__LINE__.' Ayud abrir_LSS1',[$nombrelss1,$progname,$modo]);
  # la apertura vale para el programa (y subrutinas) que la hizo, no 
  # para otros programas, 
  #    pero no se interrumpe por error; sólo hay aviso
  # si el tercer argumento es true, abre para append
  if ($modo) {
      open LSS1, ">>$nombrelss1.lss1"; #ya otro escribio antes 
  } else {
      open LSS1,">$nombrelss1.lss1"  
        or die 
         " Parece que Ud. no tiene permisos para crear archivo $nombrelss1.lss1
        en ese directorio;  así no puede trabajar simusol\n";
      print LSS1 "$presentacion";
  };
  return 1;
}#abrir_lss1
# ---------------------------------------------------------------------------
sub avejec{;
  propio("ERROR DE EJECUCION", $_[0]);
}#avejec
# ---------------------------------------------------------------------------
sub avgrav{$avisosgrav++;
  propio("ERROR GRAVE", $_[0]);
}#avgrav
# ---------------------------------------------------------------------------
sub avnograv{$avisosnograv++;
  propio("ERROR NO GRAVE?", $_[0]);
}#avnograv
# ---------------------------------------------------------------------------
sub avnoseent{$avisosnoseent++;
  # uso avisosnoseent(xxx1):
  #    xxx1: mensaje del aviso;
  #    se cuentan.      
  propio("ERROR NO SE ENTIENDE", "$_[0]\n                 se ignora");
}#avnoseent
# ---------------------------------------------------------------------------
sub cerrar_paren{
  # recibe un string y lo devuelve partido en dos (la concat. de los dos es
  # el de entrada;
  # si no comienza con parentesis el primero es vacio
  # si comienza con parentesis el primero termina al cerrarse el parentesis
  #    o al acabar... en cuyo caso se le agrega un # al final y 
  # devuelve un tercero 'error' 
  # el segundo queda con el resto, que puede ser vacio.
  # asi que si el primero no es vacio y no termino con parentesis 
  # es porque  no pudo cerrarlo  
  my $dato = $_[0]; 
  if ($dato !~ s/^\s*\(//) { return ('',$dato) };    
  my @liscar  = split '', $dato;  
  my $numabre = 1; my $out1 = '(';
  while (@liscar) {
      $_ = shift @liscar;
      $out1 .= $_;
      if ($_ eq '(') {$numabre++
      } elsif ($_ eq ')') {
          $numabre--;
          $numabre == 0 and last;
      };
  };
  my $out2 = join '',@liscar;
  $numabre > 0 and $out1 .= '#' and return ($out1,$out2,'error');
  return ($out1,$out2);
}#cerrar_paren
# ---------------------------------------------------------------------------
sub comas_invalidas{
  #detecta subexpresiones listas que no son argumentos de funcion
  #simplifica las que no molestan ....
  my $expre = 'lista'.$_[0]; #para que no moleste una lista pura
  (my $coderr,my @lista) = juntar_por_paren(',',split /\s*\,\s*/, $expre);
  @lista > 1  and return 1;
  while ($expre ne '' and $expre =~ s/(\w+)\s*\([^\(\)]+\)/$1/) {
  }; #elimino todas las posibles llamadas a funciones
  if ($expre =~ /\([^\(\)]+\,[^\(\)]+\)/) {return 1};
  return ''
}#comas_invalidas   
# ---------------------------------------------------------------------------
sub comfin{ #uso comfin('com xxxxxx', @_)   o comfin('fin xxxxxx', @_)
  # o comfin('fin xxxxxx', @_,$lisque,$ref,'impr')
  # o comfin('fin xxxxxx',,$lisque,$ref,'impr')
  # 'impr' para que llame a impr_datos con $lisque y $ref
  return ''  unless $debug;
  my @viene = @_;
  my $primera = shift @viene; my $cosa = ''; @viene and $cosa = $viene[0];
  my @refarchers =  @Simusol::GlobalesSimusol::refarchers;
  my @refgrafers =  @Simusol::GlobalesSimusol::refgrafers;
  my @reflayers =  @Simusol::GlobalesSimusol::refgrafers;
  if ($cosa) {
      if ($cosa =~ /^HASH/) {
          my @caliscosa;
          if ($cosa->{ARCHIVOCAPA}) {
              push @caliscosa, 'reflay';
	      print STDERR "parece reflay\n";
          };
          if ($cosa->{numfile} and $cosa->{capas}) {
              push @caliscosa, 'refarch';
              print STDERR "parece refarch\n";
          };
          if ($cosa->{hashclasegr}) {
              push @caliscosa, 'refgraf';
              print STDERR "parece refgraf\n"
          };
          if ($cosa->{numobj} and $cosa->{numcapa}) {
              push @caliscosa,'refcuadro';
	      print STDERR "parece refcuadro\n";
          };
          @caliscosa >1 and do {
            print STDERR ' @caliscosa ',__LINE__,' Ayud ' ,"@caliscosa\n";
          };
      };
  };
  my @simplif;
  foreach(@viene) {
#    impr_debug(__LINE__.' Ayud @viene',Dumper \@viene); 
     my $nuevo;
      my $texto = $_;
      if (not defined $texto) {
          $nuevo = 'no definido';
      } elsif ($texto =~   /^(ARRAY|HASH|SCALAR)\(/) {
          if ($texto =~ /^ARRAY\(/) { 
              my @lisundef = @$_; @lisundef = grep(do{not defined $_},@lisundef);
              if(@$_>8) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ')'    
              } elsif (@lisundef) {
                 $nuevo = 'ARRAY (' . scalar (@$_) . ' con undef)'
	      } else {
                 $nuevo = "[@$_]";
              }
          } elsif ($texto =~ /^HASH\(/) {
              $nuevo = 'HASH (' . scalar (keys (%$_ )) . ')'; 
 	      if (defined $_->{CORTOSIN}) {
	          $nuevo .= " - (($_->{CORTOSIN})): ";
              } elsif ($_->{numfile}) {
 	          my @refarchers = @Simusol::GlobalesSimusol::refarchers;
                  if (defined $refarchers[$_->{numfile}] and
                      defined $refarchers[$_->{numfile}]->{CORTOSIN}) { 
                      $nuevo .= 
                      " - ((capa de $refarchers[$_->{numfile}]->{CORTOSIN})): ";
                  };
              };
          } elsif ($texto =~ /^SCALAR\(/) {
	      $nuevo = 'SCALAR (' . length($$_) . ')';
          };
      } else {
          ($nuevo = $texto) =~ s/^\s*//;
          if ($nuevo eq '') {
              $nuevo = 'blanco';
          } elsif (length $nuevo < 16) {
          } elsif($nuevo =~ /^\//) {
              my $largo = length $nuevo; my $comi = $largo - 15;
              $nuevo = '...'. substr($nuevo,$comi); 
          } elsif (length $nuevo > 24) {
              $nuevo = substr($nuevo,0,24) .'...';
          };
          if ($texto =~ /,/) {
              $nuevo .= 'con comas';
          };
      };
      push @simplif, $nuevo;
  };
  my ($donde,$comfin);
  if ($_[0] =~ /^\s*(\w+)\s+(\S\w*)/){
     ($donde,$comfin) = ($1,$2);
    if (@_ >3 and defined $_[-1] and defined $_[-2] 
         and $_[-1] eq 'impr' and  $_[-2] =~ /HASH\(/ ) {
            impr_datos(
            "para $comfin pide comfin",['DATOS','PARAMETROS','INICIALES']
		  ,$_[-2]);
     };
  };
  eco(" $_[0](" . join(',',@simplif). ')'); #para comfin
  return '';
}#comfin
# ---------------------------------------------------------------------------
sub depurar_crudo{
  # depuura a $crudo que  supone es un texto formado de varios renglones;
  # eliminando comentarios (desde un #)
  # y limpia espacios al comienzo y al final
  # devuelve lista de renglones depurados
  my $crudo =$_[0];
  #print  __LINE__ . " Ayud crudo $crudo\n";
  my @listain = split "\n", $crudo; my @listaout =();
  foreach (@listain) {
      #tr/\t/ /; #sustituye  tabuladores por espacios; ya estan dentro de \s
      s/\#.*//g; #quita comentarios
      next if /^\s*$/;
      s/^\s+//;
      s/\s+$//;
      push @listaout, $_;
  };
  return @listaout;
}#depurar_crudo
# ---------------------------------------------------------------------------
sub eco{ 
  return if $noverb and not defined $_[1];
  #para indicar qué está haciendo simusol; para depurar
  print        "..... $_[0]\n"; 
  print STDERR "..... $_[0]\n"; 
  #si se usa > o 2> quedan separados
}#eco
# ---------------------------------------------------------------------------
sub error_progr{
   my ($archivo,$linea,@array) = @_;
   print STDERR " ===== ERROR de programación detectado en: 
       archivo $archivo      linea  $linea\n";
   print STDERR Dumper \@array;
   exit 200;
}#error_progr
# ---------------------------------------------------------------------------
sub existencia{
  comfin('comy existencia',@_);# #dirdato con cortossin
  my ($ref,$puntoext,@dirdato) = @_; my ($coderr,$mensaje) = ('','');
  my $dir = $ref->{curdirori}; my @dirdatosin; 
  foreach my $arch (@dirdato) {
      (my $archsin = $arch) =~ s/\.[^\/\.]*$//;
      $archsin =~ /_run$/ and next;
      $archsin !~ /^\// and $archsin = "$dir$archsin";
      push @dirdatosin, $archsin;
  };
  @dirdatosin = union_conjunto(@dirdatosin);
  foreach my $archsin (@dirdatosin) {    
      if (-e $archsin and not -d $archsin and not -e "$archsin$puntoext") {
          push @{$ref->{corto}},$archsin;push @{$ref->{cortosin}},$archsin;
      };         
      if (-e "$archsin$puntoext" and not -d "$archsin$puntoext" and not -e $archsin) { 
          push @{$ref->{corto}},"$archsin$puntoext";push @{$ref->{cortosin}},$archsin;
      };
      if (-e "$archsin$puntoext" and -e $archsin) {
          $coderr = 100; $mensaje = " Existen archivos
             $archsin$puntoext  y  $archsin
                Asi no puede trabajar Simusol"; 
      };
  };    
  impr_todo(__LINE__.' Ayud',$ref);  
  if (not $coderr) {
      @{$ref->{dirarray}} = @{$ref->{corto}};
      @{$ref->{corto}} == 0 and do {$coderr = 200; $mensaje = " No hay archivos"};
  };
  impr_todo(__LINE__.' Ayud',$ref);  
      
  comfin('finy existencia');
  return $coderr,$mensaje;    
}#existencia;    
# ---------------------------------------------------------------------------
sub explic{
  return if $noverb;   
  if (@_ != 1) {
      die "explic no tiene 1 argumento
          @_"
  };
  # para que sirva de ayuda al usuario; no va al archivo lss1
  print        "........ $_[0]\n";
  return  
}#explic
#----------------------------------------------------------------------------
sub hashrenglon{
  #para un hash dado por sí, forma un renglon ...
  my ($mensaje, %hash)=@_;
  my $texto = "$mensaje ";
  if (@_) {
     map(do{$texto .= "$_=>$hash{$_}; "},sort keys %hash);  
  } else {
      $texto .= '(vacio)';
  };   
  return "$texto\n";  
}#hashrenglon
#---------------------------------------------------------------------------
sub impr{
  #imprime elementos de una lista dada por sí
  my ($identy,@lista) = @_;my $largo = length($identy) + 1; # en impr
  if (@lista) {
   print "$identy --- array: ",scalar @lista," ---\n";
   foreach (@lista){
      print ' ' x $largo; 
      if (defined){ print $_,"\n"
      } else {print " undef\n"
      }
   }
  } else {print $identy,"\n";
  }
  return
}#impr
# ---------------------------------------------------------------------------
sub impr_debug{
  return unless $debug;
  if (@_ != 2) {
      die "impr_debug no tiene dos argumentos
          @_"
      };
  my ($mensaje,$cosa) = @_;
  my $texto = 'impr_debug ';
  $texto .= "$mensaje " if defined $mensaje;
  if (not defined $cosa) {
      $texto .=" no definido\n";    
  } elsif ($cosa =~ /^ARRAY\(/) {
      my $cosa1; @$cosa1 = @$cosa; 
      map(do{not defined $_ and $_ ='no definido' or
             $_ !~ /\S/ and $_ = 'blancos'},@$cosa1);
      $texto .= 'array ('.join (",", @$cosa1).")\n";	       
  } elsif ($cosa =~ /^HASH\(/) {
      my @lista; 
      foreach my $key (keys %$cosa){
          my $algo = $cosa->{$key}; defined $algo or $algo = 'undef';
          push @lista, "$key=>$algo";
      }; 
      $texto .= 'hash (' . join (',',@lista) .")\n";
  } elsif ($cosa =~ /^SCALAR\(/) { 
      $texto .=  "( escalar )$$cosa\n";
  } else { 
      $texto .= "$cosa\n";
  }; 
  print STDERR $texto;
  return
}#impr_debug    
# ---------------------------------------------------------------------------
sub impr_todo{
#  comfin('com0 impr_todo',@_);
  return unless $debug;  
  my ($mensaje,$ref)= @_;
  print STDERR " Empieza impr_todo $mensaje (ref$progr{$progname})\n";
  if ($ref->{dirarray}) {
      print STDERR " dirarray: ",scalar @{$ref->{dirarray}};
      if (@{$ref->{dirarray}} == 1) {
	  print STDERR " archivo: $ref->{dirarray}->[0]\n";
      } else {
          print STDERR " archivos\n";
      };
  };	  
  foreach my $palabra (qw(juntos curdirori outdir outdirfinal PROPIOSIN)) {
      print STDERR " $palabra $ref->{$palabra}\n"
        if defined $ref->{$palabra};
  };
  foreach my $palabra 
    (qw(corto cortosin codigo_1 codigo_s codigo_3 basearchcorto)) {
     print STDERR " $palabra ",paraimpr3puntos(130,@{$ref->{$palabra}}),"\n"
	  if $ref->{$palabra};
  };    
  print STDERR " Termina impr_todo $mensaje\n";
#  comfin('fin0 impr_todo');
  return;
}#impre_todo
# ---------------------------------------------------------------------------
sub imprhash{
  my ($identy, @hash)=@_; my ($impr, $largo);
  my $cuantos = scalar @hash; 
  if (($cuantos % 2) ) {#numero impar de valores
     $impr = pop(@hash);
     $largo = $impr;    
  } else {    
     $impr = 0;
     $largo = length($identy) + 1; # en imprhash 
  }; 
  my %hash = @hash;    
  my $texto ='';     
  foreach my $uno (sort keys %hash){
     $texto .= sprintf "%1s",  (' ' x $largo) . "$uno => $hash{$uno}\n"; 
  };
  if ($impr) {
     return $texto;
  } else {
     print "$identy --- hash: ",scalar keys %hash," ---\n";
     print "$texto\n";   
  };
  return
}#imprhash
#---------------------------------------------------------------------------
sub imprhashrenglon{
   #imprime un hash dado por sí, todo en un renglón y sin identificación
   my ($mensaje, %hash)=@_;
   print "$mensaje ";
   if (@_) {
      map((print "$_=>$hash{$_};   "),sort keys %hash)  
   } else {
      print '(vacio)'
   };   
   print "\n"  
}#imprhashrenglon
#----------------------------------------------------------------------------
sub imprlisarb{
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  ";
   imprhashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      imprnodarb('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
   return
}#imprlisarb 
#----------------------------------------------------------------------------
sub imprlisarbresu{
   # imprime una lisarb, desrrollando el primer nivel; dada por su referencia
   # $reflisarb
   my ($nombre,$reflisarb)=@_;
   my ($hash,@lista) = @$reflisarb;
   print "+++++++++++++++\n";
   print "$nombre ---lisarb refinada: ",(scalar @lista)/2 ,
          " nodarbs.  --hasharb:  \n hash ";
   imprhashrenglon('', %$hash);
   for(my $i=0;$i<@lista;$i += 2){
      my @listita= @lista[$i,$i+1];
      imprnodarbresu('(' . $i/2 . ')' . '   ',@listita) 
   };
   print "+++++++\n";
   return
}#imprlisarbresu 
#----------------------------------------------------------------------------
sub imprlislisarb{
   #imprime una lista de listas arboladas dada por sí.  
   my ($nombre,@lista)=@_;
   print "$nombre --- lista de " ,scalar @lista," lisarbs ---\n";
   for (my $i=0;$i<@lista; $i++){
      my $lisarb= $lista[$i]; 
      imprlisarbresu ("$nombre($i) ",$lisarb);
   }
   return
}#imprlislisarb
#----------------------------------------------------------------------------
sub imprnodarb{
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  print "$nombre;  tagarb:  $tagarb;   contarg: "; 
  if ($tagarb ne '0') {
     imprhashrenglon('', %{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  } else {
     print $contarb
  };
  print "\n";
  return
}#imprnodarb
#----------------------------------------------------------------------------
sub imprnodarbresu{
  #imprime un basico de lista arbolada dado por ($tagarb,$contarg)
  my ($nombre,$tagarb,$contarb)=@_;
  $nombre.=" --nodarb--  ";
  if ($tagarb ne '0') {
     print "$nombre;  tagarb:  $tagarb;   contarg: "; 
     imprhashrenglon('',%{$contarb->[0]}); 
     print '     lista de ', (scalar@{$contarb}-1)/2 ," nodarbs\n"; 
  };
  return
}#imprnodarbresu
# ---------------------------------------------------------------------------
sub interseccion_conjunto{
  # Dadas dos referencias a listas devuelve otra  con los elementos comunes
  # es mas eficiente si en la primera no hay elementos repetidos
  my ($lista1,$lista2) = @_;
  my %hash;
  foreach my $ele (@$lista1) {
      map(do{$_ eq $ele and $hash{$_}= 1},@$lista2);
  };  
  return keys %hash
}#interseccion_conjunto
# ---------------------------------------------------------------------------
sub juntar_por_paren{
  my ($pega,@listain) = @_; 
  my @listaout = ();
  my ($numabre, $numcierra, $ant, $coderr) = (0, 0, '', '');
  foreach(@listain) {
      $ant .=  "$_$pega" ;
      $numabre = ($ant =~ tr/\(//); $numcierra = ($ant =~ tr/\)//);
      if ($numabre < $numcierra) {
          avgrav ("Expresion con paréntesis ')' no apareados:\n  $_");
          return 68;    
      } elsif ( $numabre == $numcierra) {
          $ant =~ s/$pega$//;push(@listaout,$ant); 
          $ant = ''; $numabre = 0; $numcierra = 0;;
      } 
  }; #@listain
  $ant =~ s/$pega$// if $ant ne '';
  if ($numabre > $numcierra) {
      avgrav ("Expresión con paréntesis '(' no apareado:\n  $ant");
      return 69;
  };
  return $coderr,@listaout;    
}#juntar_por_paren
# ---------------------------------------------------------------------------
sub juntar_por_signos_y_paren{
  my ($pega,@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  #para juntar renglones : no 'pueden' comenzar con +-*/=\)
  #no  'pueden' terminar con \(ni con =; 
  #un renglon con = no inicial no se junta con el anterior, aunque quede
  #con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=\(])\s*\n/$1 /g; # signos finales
  $juntado =~ s/\n\s*([\,\+\-\*\/\=\)])/ $1/g; # signos iniciales
  @listain = split ("\n",$juntado);
  my ($numabre, $numcierra) = (0,0);
  foreach(@listain){
      if ($ant eq '') {
          $ant = $_;
      } elsif (/^\s*\S.+=/) {
          do{push(@listaout,$ant); $ant = $_};#puede salir con parentesis mal
      } else {
          $ant .= $pega . $_;#le saque la ,
      };
      $numabre = ($ant =~ tr/\(//); $numcierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $numabre cierra $numcierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($numabre == $numcierra );
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}#juntar_por_signos_y_paren
# ---------------------------------------------------------------------------
sub juntar_por_signosf_y_paren{
  my (@listain) = @_; my @listaout = (); my $ant = '';
  my $juntado = join ("\n",@listain);
  # no  'pueden' terminar con ,;
  # y se intentan parentesis apareados 
  # con parentesis u operaciones pendientes
  # los parentesis se tratan algebraicamente
  $juntado =~      s/([\,\+\-\*\/\=])\s*\n/$1/g; # , finales
  @listain = split ("\n",$juntado);
  my ($numabre, $numcierra) = (0,0);
  foreach(@listain){
      next unless $_; 
      $ant .= $_; 
      $numabre = ($ant =~ tr/\(//); $numcierra = ($ant =~ tr/\)//);
      #print 'Ayud ' . __LINE__ . " abre $numabre cierra $numcierra ant $ant \n";
      do {push(@listaout,$ant); $ant = ''} 
          if ($numabre <= $numcierra );#puede haber errores que se detectaran despues
  }; #@listain
  push(@listaout,$ant) if $ant ne  '';
  return (@listaout)    
}# juntar_por_signosf_y_paren 
# ---------------------------------------------------------------------------
sub mensaje{
  if (@_ != 1) {
      die "mensaje no tiene 1 argumento
          @_"
  };
  if ($debug) {
      print STDERR  "$_[0]\n";
  } else {    
      print     "$_[0]\n";
  };    
  print LSS1 "$_[0]\n";
}#mensaje
# ---------------------------------------------------------------------------
sub mensajear{
#  comfin('com mensajear',@_);
  if (@_ != 1) {
      die "mensajear no tiene 1 argumento
          @_"
  };
  my $agre = ' _ _ _ _ '; 
  if ($debug) {
     print STDERR "$agre$_[0]\n";
  } else {
      print "$agre$_[0]\n";
  };
  no warnings;
  if (tell(SALIDAls3)) {
     print SALIDAls3 "$_[0]\n"};
}#mensajear
#----------------------------------------------------------------------------
sub paraimpr3puntos{
  my ($largo,@lista) = @_;my $dato = join(' ',@lista);
  length($dato) < $largo or  $largo < 5  # en paraimpr3puntos
    or $dato = substr($dato,0,$largo - 4) . '...';
  return $dato;
}#paraimpr3puntos
# ---------------------------------------------------------------------------
sub parary{
  my ($codigo,$mensaje) = @_;
  print STDERR "$mensaje\n" if $mensaje;
 # print STDERR ' ' x 30,"Salgo de $progname con $codigo\n";
 # print ' ' x 30,"Salgo de $progname con $codigo\n";
  exit $codigo;
}#parary
# ---------------------------------------------------------------------------
sub parser{
  #comfin('com parser', @_);
  # se usa @resultados = parser(@separadores,$expresion);
  my ($sepi,$sepc,$sepd,$expresion) = @_;
  my (@lisi,@lisd);my ($lisi,$lisd);
  if ($expresion =~ /([^$sepc]+)\s*$sepc\s*(.*)/) {
      $lisi = $1; $lisd = $2; $lisd =~ s/\s*$//;
      @lisi = split(/$sepi/,$lisi);
      @lisd = split(/$sepd/,$lisd);
      (@lisi == 2   and @lisd) or return 'error';  
      $lisd[-1] =~ s/\s*$//;
      (my $coderr,@lisd)  = juntar_por_paren(',',@lisd);
  } else {return 'error'};
  #comfin('fin parser');
  return  (\@lisi,$sepc,\@lisd,$lisd);
}#parser 
# ---------------------------------------------------------------------------
sub particion{
  my ($refhash, $que) = @_;
  my @keys = keys %$refhash; 
  # se suponen ordenados con un mismo criterio los elementos en cada clase 
  # expresada con un string que es join con ' ' de los elementos
  # (si no interpreta clases distintas)
  my @clases = union_conjunto(values %$refhash);
  my $cuantos;
  for (my $i = 0; $i < @clases; $i ++) {
      my @lista = split /\s+/, $clases[$i];
      $cuantos += @lista;
  };
  #print '$refhash ', Dumper $refhash;
  $cuantos == @keys or
  do {explic("     ". join ('  ;  ', @clases) . "
      no es partición de \n          @keys;
      Número total de elementos, ". scalar @keys . ",
      y número de apariciones en las clases, $cuantos, 
      son distintos");
      return 1;
  };
  foreach my $key (@keys) {
      my $stringclase = " $refhash->{$key} ";
      $stringclase =~ /$key/ or
      do {explic("     ". join ('  ;  ', @clases) ."
          no es partición de \n          @keys;
          falla pertenencia");  
	  return 2;
      };
  };
  return ''; 
}#particion
# ---------------------------------------------------------------------------
sub pausa{
    my ($msg) =(@_,'sin mensaje');
    explic("      (CTRL-C para terminar con esto):\n"
         . "             $msg"); 
    my $dummy = <STDIN>;
    explic('');
    return
}#pausa
# ---------------------------------------------------------------------------
sub pausadebug{
    return if not $debug; 
    pausa(@_);
}#pausadebug
# ---------------------------------------------------------------------------
sub pausaver{
   my ($mensaje,$tarea)=@_;
   mensaje($mensaje);
   mensaje(
       "              Continúe $tarea
                        con   ENTER-RETURN;
               Interrumpa con CTRL-C");
   my $resp = <STDIN>;
   mensaje('') if $debug; 
}#pausaver
# ---------------------------------------------------------------------------
sub propio{
  my ($que,$mensaje) = @_;
  my $CORTOA = $GlobalesSimusol::CORTOA;
  my $PRINCIPAL = $GlobalesSimusol::PRINCIPAL;
  my $quien = ': ';
  if ($CORTOA ne $GlobalesSimusol::PRINCIPAL) {
      $quien = " ($CORTOA): ";
  };
  print LSS1 "$que$quien$mensaje\n";
  if ($debug) {
      print STDERR "($progr{$progname}) $que$quien$mensaje\n";
  } else {    
      print  "($progr{$progname}) $que$quien$mensaje\n";
  };
}#propio
# -------------------------------------------------------------------------
sub relativizar{
    #se espera nombre completo para $pwd, con su barra final;
    my ($archivo,$pwd) = @_;
    my $pwdreal = `pwd`; chomp $pwdreal;
    $archivo = "$pwdreal/$archivo" if $archivo !~ /^\//;
    $archivo = simpl_archivo("$archivo");
    $pwd =~ /^\/.+\/$/ or die "ERROR de programa ".__LINE__." Ayud\n";
    $pwdreal .= '/';
    my ($cuantos,$base) = (0,$pwdreal);
    if ($archivo =~ s/^\.\.\///) { 
        while ($archivo =~ s/^\.\.\///) {
            $cuantos ++;
            $base =~ s/\/\w+\/$/\//;
        };
        $archivo = "$base$archivo";
    }; 
    #impr_debug( __LINE__. " Ayud $archivo pwd", $pwd);
    if ($archivo =~ /^\.\//) {
        $archivo =~ s/.\///;
        $archivo = $pwdreal . $archivo;
    } elsif ($archivo =~ /^\w/) {
        $archivo = $pwdreal . $archivo;
    };
    my ($BASEARCH, $PROPIO, $CORTO, $PROPIOSINDIA, $CORTOSINDIA);
    if ($archivo =~ /(.*\/)(.*)$/) {
         $BASEARCH = $1;
         $PROPIO = $2;
         $BASEARCH =~ s/^\.\//$pwd/;
    };
    $archivo =~ s/^$pwd//;
    $CORTOSINDIA = $CORTO = $archivo;
    $CORTOSINDIA =~ s/\.dia//;
    $PROPIOSINDIA = $PROPIO;
    $PROPIOSINDIA =~ s/\.dia//;
    #impr_debug(__LINE__.' Ayud fin relativizar'
    #   , [$BASEARCH, $PROPIO, $CORTO , $PROPIOSINDIA, $CORTOSINDIA]);
    #impr_debug(__LINE__.' Ayud fin relativizar BASEARCH'
    #, $BASEARCH);
    return $BASEARCH, $PROPIO, $CORTO, $PROPIOSINDIA, $CORTOSINDIA;
}#relativizar
# ---------------------------------------------------------------------------
sub resolver_outdir{#
#lo usa simusol.pl
  comfin('comy resolver_outdir de lib/simusol',@_);
  my $ref = $_[0];  
  my $outdirori = my $curdirori = $ref->{curdirori}; my $coderr = '';
  impr_debug(__LINE__.' Ayud $outdirori',$outdirori);  
  if ($opt_hash{outdir}) {
      $outdirori = $opt_hash{outdir};
      -d $outdirori or die " $outdirori no es un directorio; no sirve para recibir archivos";
      $outdirori !~ /^\// and $outdirori ="$curdirori$outdirori";
  }; 
  ($coderr,$outdir) = simpl_directory($outdirori);
  if (not $coderr) {
      my $owner =  `stat -c %U $outdir`; chomp $owner;
      my $usted =  `whoami`;chomp $usted;
      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
        pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
          Proponga uno adecuado con la opcion -outdir\n";
  };
  $coderr and parary(250);
  $ref->{outdir} = $outdir;
  comfin('finy resolver_outdir',$outdir);
  return $outdir;
}#resolver_outdir;
# ---------------------------------------------------------------------------
sub sacar_paren_ext{
  #recibe un string y devuelve un string  solo (-1, por error)
  # o una terna  número,string, string: el numero la cantidad de pares 
  # de parentesis exteriores sacados; lo de adentro; y el resto
  my ($dato,$resto,$error) = ($_[0],'',''); my $dat;
  if ($dato =~ /^\(/) { 
      ($dat,$resto,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $dato = $dat;
  } else {
      return (0,$dato,'');
  };
  my $cuantos = 0;
  my $restin = ''; 
  while  ($restin eq '' and $dat ne '') {
      $dato = $dat;
      #impr_debug( __LINE__.' Ayud', "$_[0]     dato $dato ");
      $dato =~ s/^\((.*)\)$/$1/;
      ($dat,$restin,$error) = cerrar_paren($dato);
      defined $error and return -1; #no se cerro
      $cuantos ++;
  };
  return $cuantos, $dato,$resto;
}#sacar_paren_ext
# ---------------------------------------------------------------------------
sub simpl_archivo{ #elimina '..' intercalados en nombre de archivo
    #se supone que no hay errores de sintaxis ni espacios 
    # al princ.ni al final
    # y que no termina en /, pues no es un directorio, pero si empieza con /
    my $arch = $_[0]; $arch =~ s/^\///;
    my @lista = split /\//, $arch;
    @lista = grep (do{$_ ne '.'}, @lista);
    my $hay =1;
    while ($hay){
        $hay ='';
        for(my $i = 0; $i <@lista-1; $i ++) {
            if ($lista[$i+1] eq '..'  and $lista[$i] ne '..') {
 	        delete $lista[$i]; delete $lista[$i+1]; 
                if (defined $lista[$i+2] and $lista[$i+2] eq '..') {
                    $hay= 1;
                }
                $i ++;
	    } ;
        };
        @lista = grep(defined $_,@lista);    
    };  #ya no hay '..' intercalados
    my @listadospuntos = grep($_ eq '..',@lista);
    return '/'. join '/',@lista;
}#simpl_archivo
# ---------------------------------------------------------------------------
sub simpl_directory{ #elimina '..' o '.' intercalados en nombre del directorio
  comfin('comy simpl_directory',@_); 
  my $direin = $_[0]; my ($coderr,$direout) = ('',$direin);
  my $curdir = `pwd`;chomp $curdir;
  if (-d $direin) {
      chdir $direin;
      $direout = `pwd`; chomp $direout;$direout =~ s/([^\/])$/$1\//;
  } else {
      $coderr = 1;
  };
  chdir $curdir;# si $curdir no fue chompeado, resultaria inutil  
  comfin('finy simpl_directory',$coderr,$direout);
  return $coderr,$direout; 
}#simpl_directory 
# ---------------------------------------------------------------------------
sub textear_MENSAJES{
  my $texto = '   '. join("   \n",@MENSAJES);
  @MENSAJES = ();
  return $texto;
}#textear_MENSAJES
# ---------------------------------------------------------------------------
sub texto{
    # texto que debe ser traducido a otro idioma (además de los mensaje etc
    return $_[0];
}#texto
# ---------------------------------------------------------------------------
sub union_conjunto{
  # Dada un lista devuelve la "misma" sin elementos repetidos (no respeta el
  # orden)
  my %hash;
  map(do{$hash{$_}= 1 if defined $_},@_);
  return keys %hash
}#union_conjunto
# ---------------------------------------------------------------------------
sub union_conorden{
  # Dada un lista devuelve la "misma" sin elementos repetidos (no respeta el
  # orden)
  my %hash;
  foreach (@_) {
      next unless defined $_;
      if ($hash{$_}) {
          $_ = undef;
      } else {
          $hash{$_} = 1
     }; 
  };
  my @lista = grep (defined $_,@_);
  return @lista;
}#union_con_orden
# ---------------------------------------------------------------------------
1;
